#*-* coding: utf-8 *-*
from socket import *
from Communicator import *


class AbsServer(Communicator):
    def __init__(self,name):
        Communicator.__init__(self,name)
    def Init(self,ip,port):
        self.IP = str(ip)
        self.Port = int(port)
        self.c = None
        Communicator.ResetFlag(self)
    def DatProc(self,dat): 
        from Project import pj 
        self.out(dat)
    def Bypass(self,dat): 
        from Project import pj 
        if pj.Sys.GetAbsIsUsing() == 0 : return
        if dat[len(dat)-1] != '\n' : dat + '\r\n'
        if self.c != None : self.c.send(dat.encode())
    def Send(self,dat): 
        from Project import pj 
        if pj.Sys.GetAbsIsUsing() == 0 : return
        if dat[len(dat)-1] != '\n' : dat + '\r\n'
        if self.c != None : self.c.send(dat.encode())
    def Start(self):
        from Project import pj 
        s = socket(AF_INET, SOCK_STREAM)
        s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        s.bind((self.IP, self.Port))
        s.listen(1)
        self.out('Start Listen ({},{})'.format(self.IP, self.Port))
        #Append log for connection.
        while 1:
            try: 
                if self.c != None : 
					self.c.close()
					self.c = None
					self.out('Re - Accepted, self.c = None')
                    
                (c, addr) = s.accept() 
                self.out('Accepted {}'.format(addr))
                self.c = c 
                pj.Log.PushConnected('Connected modem.')
                # Accept events
                if pj.Sys.GetAbsClass() == 0 and pj.Sys.GetAbsRfterm() > 0 :
					self.SendAcceptMsgForIDirect()    
                while 1:
					c.settimeout(40.0)
					line = c.recv(1024)
					if len(line) == 0 : break
					# if pj.Sys.GetAbsIsUsing() == 0 : continue
					# self.out("*"+line)
					if pj.Sys.GetAbsIsUsing() == 1 :pj.AbsComm.Bypass(line),self.SetFlag()
					# self.DatProc(line)
                # self.Proc(line.decode())
                # print('Received from', addr, line.decode())
            except: self.out('Receive Error')  
            c.close()
            self.out('Close server. ({})'.format(self.Port))
            pj.Log.PushDisconnected('Disonnected modem.')
            self.c = None
            self.ResetFlag()
        self.out('Thread Closed(*)')
        s.close()
    def CheckConnection(self): 
        return 0 if self.c == None else 1
    def SendAcceptMsgForIDirect(self): 
        from Project import pj 
        tmp = "IDIRECT:ident rftermtype={},"\
                "acuvendor=KNS,"\
                "aimserialnum={},"\
                "aimtype={},"\
                "aimswrev={},"\
                "bimserialnum={},"\
                "bimtype={},"\
                "bimswrev={},"\
                "LNB-LPN={},"\
                "LNB-LSN={},"\
                "L-MID={},"\
                "LNB-FID={}\r\n".format(
					pj.Sys.GetAbsRfterm(),
					'VCS2020102400',
					'VCS',
					'VCS0.400',
					'',
					'',
					'',
					'',
					'',
					'',
					'',
                    )
        self.Bypass(tmp)
        self.out(tmp)
        

