#*-* coding: utf-8 *-*
import os
import time
from socket import *
from Antenna import *
from Communicator import * 

class AntCommunicator(Communicator):
    def __init__(self,name):
        self.flag = True
        self.Soc = None
        self.Connected = False
        Communicator.__init__(self,name)
        self.TxArr = []
        p = Thread(target=self.TxWorker)
        p.start()
    def Init(self,ip,port):
        self.Ant = Antenna('Antenna')
        self.IP = str(ip)
        self.Port = int(port)
        Communicator.ResetFlag(self)
    # def Send(self,dat):
        # try :
            # self.Soc.sendall(dat)
        # except: self.out('* Antenna Socket Error (Send) ')
    def Send(self,dat):
        # if self.Connected : self.Soc.sendall(dat) 
        # self.out(dat)
        
        tmp = str(dat)
        # tmp = tmp + '\r\n'
        self.TxArr.append(tmp)
    def Start(self):
		while 1:
			self.Soc = socket(AF_INET, SOCK_STREAM)
			self.out('Create New Socket')
			try:
				self.Soc.connect((self.IP,self.Port))
				self.out('Connected ({},{})'.format(self.IP, self.Port))
				self.Connected = True
				while self.IsRun() :
					self.Soc.settimeout(5.0)
					line = self.Soc.recv(1024)
					# try:
						# soc.settimeout(5.0)
						# line = soc.recv(1024)
					# except:
						# self.out('AntCommunicator Received Timeout')
					if line[0:2] == '$K' : 
						lines = line.split(',')
						if len(lines) > 3 : 
							# self.out(line)
							if lines[2] == 'STS' : self.Ant.DatProc(line)
							elif lines[2] == 'GPS' : self.Ant.Nmea.BurstGpsProc(line)
						self.SetFlag()
				self.ResetFlag()
			except: self.out('AntCommunicator Retry.... (wait 5sec)')
			self.Connected = False
			self.Soc = None
			time.sleep(5)
    def TxWorker(self):
        from Project import pj 
        time.sleep(5)
        while True:
            time.sleep(0.07)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                # self.out("len {}  {}".format(len(self.TxArr),dat ))
                try:
                    if self.Connected : self.Soc.send(dat.encode())
                except: self.out('Transfer Error - Antenna Communicator')

	
