#-*- coding:utf-8 -*-
import time
import json
from threading import Thread

class VCS:
    def __init__(self):
        # Driving
        # 0	Off
        # 1	On
        # 2	Auto start when power on
        self.Driving = 0
        # AntSel
        # 0	All blocked
        # 1	Use antenna A only
        # 2	Use antenna B
        # 3	Auto mode (depend on lock status of antenna, if locked both a and b, active a.)
        self.AntSel = 0
        # AntAuto
        # 1 or 2	Select by checking the connection status of A and B, A priority.
        self.AntAuto = 0
        # RefFreqSel (NOP)
        # 0	Internal
        # 1	External
        # 2	Modem
        self.RefFreqSel = 0 
        self.RefFreqAuto = 0
        self.OpTime = 0
        
        self.Link = 0
        self.Lock = 0
        self.LockFromConsole = 0
        
        self.SyncMode = 0
        
        # Workers
        w1 = Thread(target=self.Worker)
        w1.start()
    def Worker(self):
		while True:
			time.sleep(1)
			self.OpTime += 1