#-*- coding:utf-8 -*-
import sys
import datetime
import sqlite3


def Systime(): 
    dt = str(datetime.datetime.now())
    return dt[0:23]
 
def CheckTable() :

    ''' Open '''
    sqlconn = sqlite3.connect("/home/pi/proj/vcs/dev/app/beta/dump/system.db")
    cur = sqlconn.cursor()  
    
    sqlconn.execute("DROP TABLE logs")
    tmp = 'CREATE TABLE IF NOT EXISTS logs( id INTEGER PRIMARY KEY AUTOINCREMENT, ' \
            'datetime TEXT, ' \
            'name TEXT, ' \
            'status TEXT, ' \
            'data TEXT, ' \
            'decription TEXT ' \
            ' )'
    sqlconn.execute(tmp)
    sqlconn.commit() 
    print "CREATE TABLE burst."
    
                            
    sql = "insert into logs(datetime, name, status, data, decription) values (?,?,?,?,?)"
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "operationg", "start", ""))
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "gps", "valid", "external"))
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "gps", "not valid", "external"))
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "gps", "valid", "internal"))
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "gps", "not valid", "internal"))
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "gyro", "valid", ""))
    cur.execute(sql, ('2021-01-24 07:05:46.061' ,"system", "gyro", "not valid", ""))
    
    cur.execute(sql, (Systime(),"system", "modem", "connection", ""))
    cur.execute(sql, (Systime(),"system", "modem", "disconnection", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "connection", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "disconnection", ""))
    cur.execute(sql, (Systime(),"system", "ant-b", "connection", ""))
    cur.execute(sql, (Systime(),"system", "ant-b", "disconnection", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "linked", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "unlinked", ""))
    cur.execute(sql, (Systime(),"system", "ant-b", "linked", ""))
    cur.execute(sql, (Systime(),"system", "ant-b", "unlinked", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "locked", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "unlocked", ""))
    cur.execute(sql, (Systime(),"system", "ant-b", "locked", ""))
    cur.execute(sql, (Systime(),"system", "ant-b", "unlocked", ""))
    cur.execute(sql, (Systime(),"system", "ant-a", "actived", "auto"))
    cur.execute(sql, (Systime(),"system", "ant-b", "actived", "auto"))
    
    cur.execute(sql, (Systime(),"setting", "lband", "mute", ""))
    cur.execute(sql, (Systime(),"setting", "lband", "ant-a", ""))
    cur.execute(sql, (Systime(),"setting", "lband", "ant-b", ""))
    cur.execute(sql, (Systime(),"setting", "lband", "auto", ""))
    cur.execute(sql, (Systime(),"setting", "refsig", "int", ""))
    cur.execute(sql, (Systime(),"setting", "refsig", "ext", ""))
    cur.execute(sql, (Systime(),"setting", "refsig", "mod", ""))
    cur.execute(sql, (Systime(),"setting", "sync", "on", ""))
    cur.execute(sql, (Systime(),"setting", "sync", "off", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "nmea2000", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "nmea0183", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "syncstep", "12.2"))
    cur.execute(sql, (Systime(),"setting", "gyro", "external", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "user", "24.2"))
    cur.execute(sql, (Systime(),"setting", "gyro", "auto", ""))
    
    
    cur.execute(sql, (Systime(),"setting", "lband", "mute", ""))
    cur.execute(sql, (Systime(),"setting", "lband", "ant-a", ""))
    cur.execute(sql, (Systime(),"setting", "lband", "ant-b", ""))
    cur.execute(sql, (Systime(),"setting", "lband", "auto", ""))
    cur.execute(sql, (Systime(),"setting", "refsig", "int", ""))
    cur.execute(sql, (Systime(),"setting", "refsig", "ext", ""))
    cur.execute(sql, (Systime(),"setting", "refsig", "mod", ""))
    cur.execute(sql, (Systime(),"setting", "sync", "on", ""))
    cur.execute(sql, (Systime(),"setting", "sync", "off", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "nmea2000", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "nmea0183", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "syncstep", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "external", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "user", ""))
    cur.execute(sql, (Systime(),"setting", "gyro", "auto", ""))
    
    
    cur.execute(sql, (Systime(),"setting", "gps-nmea", "rmc", "4800"))
    cur.execute(sql, (Systime(),"setting", "gps-nmea", "gga", "4800"))
    
    sqlconn.commit()
    
    # sql = "SELECT * FROM logs WHERE id > 20"
    sql = "SELECT * FROM logs WHERE datetime >= '2021-01-25'"
    cur.execute(sql)
    rows = cur.fetchall() 
    for row in rows: print(row) 
    
    ''' Select '''
    # cur.execute("SELECT * FROM burst WHERE datetime BETWEEN '2021-01-19 01:07:54.093' AND '2021-01-19 01:08:14.475'") 
    # cur.execute("SELECT * FROM burst") 
    # cur.execute("SELECT * FROM burst WHERE id BETWEEN 90 AND 100 ") 
    # cur.execute("SELECT * FROM burst WHERE id % 5 == 0") 
    # cur.execute("SELECT * FROM burst WHERE id % 1000 == 0") 
    # cur.execute("SELECT * FROM burst WHERE (datetime BETWEEN '2021-01-20 01:20' AND '2021-01-20 01:21') AND (id % 5 == 0)") 
    # rows = cur.fetchall() 
    # for row in rows: print(row) 
    
    ''' Delete, manage db.'''
    # cur.execute("DELETE FROM burst WHERE datetime < '2021-01-20 00:20'") 
    # sqlconn.commit()
    
    ''' Rows Number.'''
    # cur.execute("SELECT COUNT(*) FROM burst") 
    # print "Current row number is {} in burst".format(int(cur.fetchone()[0]))
    
    ''' First/Last Rows.'''
    # cur.execute("SELECT * FROM burst LIMIT 1") 
    # print "First row : {}".format(cur.fetchone())
    # cur.execute("SELECT * FROM burst ORDER BY ID DESC LIMIT 1") 
    # print "Last row : {}".format(cur.fetchone())
    # cur.execute("SELECT * FROM burst WHERE (datetime BETWEEN '2021-01-20 01:00' AND '2021-01-20 02:00') LIMIT 1") 
    # print "Time Range - 1, First: {}"
    # print cur.fetchone()
    # # cur.execute("SELECT COUNT(*) FROM burst WHERE (datetime BETWEEN '2021-01-20 01:00' AND '2021-01-20 02:00') AND (id % 1000 == 0)")     # Fixed 
    # max_range = 5
    # cur.execute("SELECT COUNT(*) FROM burst WHERE (datetime BETWEEN '2021-01-20 01:00' AND '2021-01-20 02:00')")                            # Dynamic - 1
    # interval = int(int(cur.fetchone()[0]) / max_range)
    # cur.execute("SELECT * FROM burst WHERE (datetime BETWEEN '2021-01-20 01:00' AND '2021-01-20 02:00') AND (id % {} == 0)".format(interval))  # Dynamic - 2
    # rows = cur.fetchall() 
    # print "Time Range - 2, 5 Row "
    # for row in rows: print(row) 
    # cur.execute("SELECT * FROM burst WHERE (datetime BETWEEN '2021-01-20 01:00' AND '2021-01-20 02:00') ORDER BY ID DESC LIMIT 1 ")     # Fixed 
    # print "Time Range - 3, Last: "
    # print cur.fetchone()
    
   
    # print "* Range"
    # cur.execute("SELECT * FROM burst WHERE datetime BETWEEN '2021-01-22' AND '2021-01-23'") 
    # rows = cur.fetchall() 
    # for row in rows: print(row) 
    
    ''' Close '''
    sqlconn.close()

def main():
    CheckTable()

if __name__ == "__main__":
    main()