	function AddUIEvents(){		
		$('.update').find(".apply").click(function(){ AddEventCommand('req-update-apply'), $('#package-update').modal('hide')});
		$('.update').find(".reboot").click(function(){ $('#package-update').modal('show')});
		$('.update').find(".reload").click(function(){ AddEventCommand('req-update-cancel'), location.reload();});
		$('.package').find(".apply").click(function(){ 
			if(ChangeVersion==0) return;
			AddEventObject({Id: 'change-package', Package:ChangeVersion})
			//console.log({Id: 'change-package', Package:ChangeVersion})
			$('#package-change').modal('hide')
		});
	}
	
	 
	var conf = {
		obj:null,
		edit:null,
		Update: function (obj){ 
		}
	}
	   
	var worker = { i1:null,i2:null,i3:null }
	var reboot_flag = false;
	window.onload = function() {	
		AddUIEvents()
		AddEventCommand('req-version')
		//Send event
		setInterval(function() { if(!reboot_flag) SendEvent({Id:"get-vcs-info"})}, 500);
		setInterval(function(){ if(commands.length>0) SendEventForUpdate(commands.shift());}, 50);
		setInterval(function(){
			if(UpdateStatus.Flag){
				AddEventCommand('req-update-status') 
			}
		}, 200);
	};
	
	var UpdateStatus = { Flag:false}
	var ProcRecvError = 0;
	function ProcRecv(resp){	
		try{ 
			// console.log(resp)
			var obj = JSON.parse(resp);}
		catch{ 
			if(ProcRecvError++>10) UpdateStatus.Flag = false			
			console.log("[Error] json format is wrong. => "+resp);
			return false;
		}  
		
		try{ if(obj.Id == 'resp-vcs-info'){ } } catch{ return false; }
		
		// console.log(resp) 
		
		if(obj.Id == 'resp-version'){
			var tmp = 'Project :' + obj.Current.Name.toUpperCase() +' / Version: '+ obj.Current.Version
			$('.update').find(".msg0").html(tmp);
			tmp = "<ul>" 
			for(var x in obj.Packages){
				if(x>5) break;
				//console.log(obj.Packages[x]); 
				tmp += ('<div class="form-group row">'+
							'<label class="col-4">Version</label>'+
							'<label class="col-4">'+obj.Packages[x]+'</label>'+
							'<div class="col-4">'+
							'<button type="button" class="btn btn-outline-secondary" onclick="ChangePackage('+obj.Current.Version+","+obj.Packages[x]+')">Change</button>'+
							'</div>'+
						'</div>');
			} 
			tmp += "</ul>"
			$('.package').find(".list").html(tmp); 
			 
		}else if(obj.Id == 'resp-update'){
			UpdateStatus = obj.Status
			if(obj.Status.Flag){ 
			
				if (obj.Status.Step==3) $('.update').find(".reboot").attr("disabled", false); 
				else $('.update').find(".reboot").attr("disabled", true); 
			
				if(obj.Status.Step==3){ 
					$('.update').find(".msg5").html("Ready for apply (Uploaded Package Version: "+obj.Status.Version+')');
					$('.update').find(".msg2_0").html("Ready for apply.");
					var tmp = " Current Version: "+obj.Current.Version + " <i class='flaticon2-arrow'></i>" + " Update Version: "+obj.Status.Version;
					$('.update').find(".info0").html(tmp);
				} else if(obj.Status.Step==4){  $('.update').find(".msg2_0").html("Installing new package.");
				} else if(obj.Status.Step==5){  $('.update').find(".msg2_1").html("Installed.");
				} else if(obj.Status.Step==6){  $('.update').find(".msg2_2").html("Rebooted." ); 
					reboot_flag = true; 
					StopCheckConnection(),setTimeout("location.reload()", 30000);
					return false;   
				} else if(obj.Status.Step==7){ 
					$('.update').find(".msg5").html("Uploaded file is wrong.");
					$('.update').find(".msg2_0").html("");
					$('.update').find(".msg2_1").html("");
					$('.update').find(".msg2_2").html("");
				}
			}  
		}
		else if(obj.Id == 'resp-anta-info') $(".status.anta").html(JSON.stringify(obj,null,2)); 
		else if(obj.Id == 'resp-antb-info') $(".status.antb").html(JSON.stringify(obj,null,2)); 
		else if(obj.Id == 'resp-vcs-info'){
			//Gyro StepSync Flag
			if(obj.GyroSyncStepStartupFlag) window.location.replace('index.html')
		}
		else if(obj.Id == 'resp-conf' || obj.Id == 'edit-conf'){}
		else if(obj.Id == 'reload-conf'){conf.Update(obj)}
		else if(obj.Id == 'save-conf'){}
		else if(obj.Id == 'resp-update-cancel'){ resetMessage(), $('.update').find(".reboot").attr("disabled", true);  }
		
		try{ 
			if(obj.Id =="resp-vcs-info" && obj.Event.length > 0){ _updatelog(obj.Event) } 
		}
		catch{ return true; }
		return true;
	} 
	
	var ChangeVersion = 0
	function ChangePackage(ver,dat){
		//console.log(dat);
		//AddEventObject({Id: 'change-package', Package:dat})
		$('#package-change').modal('show')
		var tmp = " Current Version: "+ver+ " <i class='flaticon2-arrow'></i>" + " Update Version: "+dat;
		$('.package').find(".info0").html(tmp);
		ChangeVersion = dat
	}
	
	
	function resetMessage(){
		$('.update').find(".msg1").html("");
		$('.update').find(".msg2").html("");
		$('.update').find(".msg3").html("");
		$('.update').find(".msg4").html("");
		$('.update').find(".msg5").html("");
		$('.update').find(".msg2_0").html("");
		$('.update').find(".msg2_1").html("");
		$('.update').find(".msg2_2").html("");
	}
	
	function uploadFile(){
		
		resetMessage();
		
		if(document.getElementById('file1').files.length < 1){
			$('.update').find(".msg3").html("No selected file");
			return;
		}
	
		//var file = _("file1").files[0];
		var file = document.getElementById('file1').files[0];
		var formdata = new FormData(); 
		formdata.append("file1", file);
		var ajax = new XMLHttpRequest();
		ajax.upload.addEventListener("progress", progressHandler, false);
		ajax.addEventListener("load", completeHandler, false);
		ajax.addEventListener("error", errorHandler, false);
		ajax.addEventListener("abort", abortHandler, false);
		ajax.open("POST", "assets/php/upload_parser.php");
		ajax.send(formdata);
	}
	
	function progressHandler(event){
		$('.update').find(".msg2").html("Uploaded "+event.loaded+" bytes of "+event.total);
		var percent = (event.loaded / event.total) * 100;
		$(".progress-bar").width(Math.round(percent).toString()+'%');
			$('.update').find(".msg3").html(Math.round(percent)+"% uploaded... please wait");
	}
	function completeHandler(event){
		$('.update').find(".msg4").html("Uploaded Compete");
		AddEventCommand('req-update-start')
	}
	function errorHandler(event){
		$('.update').find(".msg4").html("Upload Failed")
	}
	function abortHandler(event){
		$('.update').find(".msg4").html("Upload Aborted")
	}
	
	
