#*-* coding: utf-8 *-*
from Protocol import * 

class ModemMessage(Protocol):
    def __init__(self,name):
        Protocol.__init__(self, name)
        self.ID = 0
        self.Name = "Unknown"
        self.Position = 0
        self.SchMethod = 0
        self.SchThreshold = 0
        self.TrkMethod = 0
        self.RxPol = 0
        self.TxPol = 0
        self.TRxPol = 0
        self.SkewTrimAng = 0
        self.BucLo = 0
        self.LowLo = 0
        self.HighLo = 0
        self.LnbBandSel = 0
        self.TpFreq = 0
        self.TpSymb = 0
        self.RollOff = 0
        self.RcvCnt = 0
        self.UTC = 0
    def GetArray(self):
        dat = { 
            'ID':self.ID,
            'Name':self.Name,
            'Position':self.Position,
            'SchMethod':self.SchMethod,
            'SchThreshold':self.SchThreshold,
            'TrkMethod':self.TrkMethod,
            'RxPol':self.RxPol,
            'TRxPol':self.TRxPol,
            'SkewTrimAng':self.SkewTrimAng,
            'LowLo':self.LowLo,
            'HighLo':self.HighLo,
            'LnbBandSel':self.LnbBandSel,
            'TpFreq':self.TpFreq,
            'TpSymb':self.TpSymb,
            'RollOff':self.RollOff,
            'RcvCnt':self.RcvCnt,
            'UTC':self.UTC,
        } 
        return dat       